diff --git a/include/sway/output.h b/include/sway/output.h
index ea7a217418..e0166512cf 100644
--- a/include/sway/output.h
+++ b/include/sway/output.h
@@ -31,6 +31,7 @@ struct sway_output {
 
 	int lx, ly;
 	int width, height;
+	enum wl_output_subpixel original_subpixel;
 
 	bool enabled, configured;
 	list_t *workspaces;
diff --git a/sway/config/output.c b/sway/config/output.c
index ee22240484..124b6acc72 100644
--- a/sway/config/output.c
+++ b/sway/config/output.c
@@ -311,11 +311,14 @@ bool apply_output_config(struct output_config *oc, struct sway_output *output) {
 		sway_log(SWAY_DEBUG, "Set %s scale to %f", oc->name, oc->scale);
 		wlr_output_set_scale(wlr_output, oc->scale);
 	}
-	if (oc && oc->subpixel != WL_OUTPUT_SUBPIXEL_UNKNOWN) {
+	enum wl_output_subpixel subpixel = output->original_subpixel;
+	if (oc && oc->subpixel && oc->subpixel != WL_OUTPUT_SUBPIXEL_UNKNOWN) {
+		subpixel = oc->subpixel;
 		sway_log(SWAY_DEBUG, "Set %s subpixel to %s", oc->name,
-			sway_wl_output_subpixel_to_string(oc->subpixel));
-		wlr_output_set_subpixel(wlr_output, oc->subpixel);
+			sway_wl_output_subpixel_to_string(subpixel));
 	}
+	wlr_output_set_subpixel(wlr_output, subpixel);
+
 	if (oc && oc->transform >= 0) {
 		sway_log(SWAY_DEBUG, "Set %s transform to %d", oc->name, oc->transform);
 		wlr_output_set_transform(wlr_output, oc->transform);
diff --git a/sway/tree/output.c b/sway/tree/output.c
index e0a66e0bdf..6b0ea52fbf 100644
--- a/sway/tree/output.c
+++ b/sway/tree/output.c
@@ -71,6 +71,7 @@ struct sway_output *output_create(struct wlr_output *wlr_output) {
 	node_init(&output->node, N_OUTPUT, output);
 	output->wlr_output = wlr_output;
 	wlr_output->data = output;
+	output->original_subpixel = wlr_output->subpixel;
 
 	wl_signal_init(&output->events.destroy);
 
